12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391139213931394139513961397139813991400140114021403140414051406140714081409141014111412141314141415141614171418141914201421142214231424142514261427142814291430143114321433143414351436143714381439144014411442144314441445144614471448144914501451145214531454145514561457145814591460146114621463146414651466146714681469147014711472 |
- #!/bin/bash
- # Copyright (C) 2016 Paul Kocialkowski <contact@paulk.fr>
- #
- # This program is free software: you can redistribute it and/or modify
- # it under the terms of the GNU General Public License as published by
- # the Free Software Foundation, either version 3 of the License, or
- # (at your option) any later version.
- #
- # This program is distributed in the hope that it will be useful,
- # but WITHOUT ANY WARRANTY; without even the implied warranty of
- # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
- # GNU General Public License for more details.
- #
- # You should have received a copy of the GNU General Public License
- # along with this program. If not, see <http://www.gnu.org/licenses/>.
- PROJECT_ACTIONS_GENERIC="usage download extract update build install release clean"
- PROJECT_ACTIONS_HELPERS="arguments"
- PROJECT_FUNCTIONS=$( for action in $PROJECT_ACTIONS_GENERIC ; do echo "$action" "$action""_check" ; done ; echo "$PROJECT_ACTIONS_HELPERS" )
- INSTALL_REGEX="\([^:]*\):\(.*\)"
- project_include() {
- local project=$1
- local project_path=$( project_path "$project" )
- unset -f $PROJECT_FUNCTIONS
- . "$project_path/$project"
- project_helper_include "$project"
- }
- project_helper_include() {
- local project=$1
- local project_path=$( project_path "$project" )
- local include="$project_path/$project-helper"
- if [ -f "$include" ]
- then
- . "$include"
- fi
- }
- project_check() {
- local project="${1##*/}"
- local project_path="$(project_path "${project}")"
- if ! [[ -f "${project_path}/${project}" ]]; then
- return 1
- fi
- }
- project_function_check() {
- local project=$1
- local function=$2
- project_include "$project"
- if ! function_check "$function"
- then
- return 1
- fi
- return 0
- }
- project_action() {
- local action=$1
- shift
- local project=$1
- shift
- local arguments=$@
- (
- set +e
- if ! project_check "$project"
- then
- printf "Project $project check failed\n" >&2
- return 1
- fi
- project_action_check "$action" "$project" "$@"
- # Why is this here? Commented out for now.
- # if [ $? -eq 0 ]
- # then
- # return 0
- # fi
- project_include "$project"
- if ! function_check "$action"
- then
- return 0
- fi
- printf "Project $project $action (with ${arguments:-no argument})\n" >&2
- (
- set -e
- "$action" "$@"
- )
- if [ $? -ne 0 ]
- then
- printf "\nProject $project $action (with ${arguments:-no argument}) failed\n" >&2
- return 1
- else
- printf "\nProject $project $action (with ${arguments:-no argument}) completed\n" >&2
- fi
- )
- }
- project_action_check() {
- local action=$1
- shift
- local project=$1
- shift
- (
- set +e
- if ! project_check "$project"
- then
- printf "Project $project check failed\n" >&2
- return 1
- fi
- project_include "$project"
- if ! function_check "$action""_check"
- then
- return 1
- fi
- for project_force in $PROJECTS_FORCE
- do
- if [ "$project_force" = "$project" ]
- then
- return 1
- fi
- done
- (
- set -e
- "$action""_check" "$@"
- )
- )
- }
- project_action_helper() {
- local helper=$1
- shift
- local project=$1
- shift
- (
- set +e
- if ! project_check "$project"
- then
- printf "Project $project check failed\n" >&2
- return 1
- fi
- project_include "$project"
- if ! function_check "$helper"
- then
- return 0
- fi
- (
- set -e
- "$helper" "$@"
- )
- )
- }
- project_action_arguments() {
- local action=$1
- shift
- local project=$1
- shift
- project_action_arguments_verify_recursive "$action" "$project" "$@"
- project_action_arguments_recursive "$action" "$project" "$@"
- }
- project_action_arguments_verify_recursive() {
- local action=$1
- shift
- local project=$1
- shift
- local action_helper_arguments
- # Store final argument.
- local argument=${@:$#}
- local test
- if [ $# -gt 1 ]
- then
- # Set previous arguments.
- set "${@:1:$#-1}"
- elif [ $# -eq 1 ]
- then
- shift
- else
- return 0
- fi
- action_helper_arguments=$( project_action_helper "arguments" "$project" "$@" )
- if ! [ -z "$action_helper_arguments" ]
- then
- test=$( echo "$action_helper_arguments" | grep -P "^$argument$" || true )
- if [ -z "$test" ]
- then
- printf "Invalid argument $argument for project $project action $action\n" >&2
- return 1
- fi
- fi
- project_action_arguments_verify_recursive "$action" "$project" "$@"
- }
- project_action_arguments_recursive() {
- local action=$1
- shift
- local project=$1
- shift
- local action_helper_arguments
- local argument
- local ifs_save
- action_helper_arguments=$( project_action_helper "arguments" "$project" "$@" )
- if [ $? -ne 0 ] || [ -z "$action_helper_arguments" ]
- then
- project_action "$action" "$project" "$@"
- else
- # This it to allow space characters in arguments.
- ifs_save=$IFS
- IFS=$'\n'
- for argument in $( echo "$action_helper_arguments" )
- do
- (
- IFS=$ifs_save
- # Only a single argument at a time is returned by the helper.
- project_action_arguments_recursive "$action" "$project" "$@" "$argument"
- )
- done
- IFS=$ifs_save
- fi
- }
- project_action_projects() {
- local action=$1
- shift
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local project_projects_path="$project_path/$CONFIGS/$PROJECTS"
- local project_projects_action_path="$project_path/$CONFIGS/$PROJECTS-$action"
- local arguments
- local path
- if [ -f "$project_projects_action_path" ]
- then
- path=$project_projects_action_path
- else
- path=$project_projects_path
- fi
- # Multiple arguments can be read from the file.
- while read arguments
- do
- eval "project_action_arguments "$action" $arguments"
- done < "$path"
- }
- project_path() {
- local project=$1
- local project_path="$root/$PROJECTS/$project"
- echo "$project_path"
- }
- project_sources_path() {
- local project=$1
- shift
- local repository=$1
- shift
- local sources_path
- local argument
- local path
- # Check downloaded and extracted sources first, using "$project."
- path="$root/$SOURCES/$project"
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path-$argument"
- fi
- if ! directory_filled_check "$path"
- then
- continue
- fi
- sources_path=$path
- done
- if ! [ -z "$sources_path" ]
- then
- echo "$sources_path"
- return
- fi
- # Check downloaded sources then, using "$repository."
- path="$root/$SOURCES/$repository"
- if directory_filled_check "$path"
- then
- echo "$path"
- return
- fi
- # Check project sources finally, using "$project."
- path="$root/$PROJECTS/$project/$SOURCES"
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path/$argument"
- fi
- if ! directory_filled_check "$path"
- then
- continue
- fi
- sources_path=$path
- done
- if ! [ -z "$sources_path" ]
- then
- echo "$sources_path"
- return
- fi
- }
- project_sources_directory_filled_check() {
- local project=$1
- shift
- local sources_path=$( project_sources_path "$project" "$@" )
- test ! -z "$sources_path"
- }
- project_sources_directory_filled_error() {
- local project=$1
- shift
- local arguments=$@
- local sources_path=$( project_sources_path "$project" "$@" )
- if ! [ -z "$sources_path" ]
- then
- printf "Sources directory for project $project (with ${arguments:-no argument}) already exists\n" >&2
- return 1
- else
- return 0
- fi
- }
- project_sources_directory_missing_empty_error() {
- local project=$1
- shift
- local arguments=$@
- local sources_path=$( project_sources_path "$project" "$@" )
- if [ -z "$sources_path" ]
- then
- printf "Sources directory for project $project (with ${arguments:-no argument}) missing or empty\n" >&2
- return 1
- else
- return 0
- fi
- }
- project_sources_archive() {
- local project=$1
- shift
- local sources_archive
- local argument
- local path="$root/$SOURCES/$project"
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path-$argument"
- fi
- local archive="$path.$TAR_XZ"
- if ! [ -f "$archive" ]
- then
- continue
- fi
- sources_archive=$archive
- done
- if ! [ -z "$sources_archive" ]
- then
- echo "$sources_archive"
- fi
- }
- project_sources_archive_extract() {
- local project=$1
- shift
- local arguments=$@
- local archive=$( project_sources_archive "$project" "$@" )
- local destination=$( dirname "$archive" )
- printf "Extracting source archive for $project (with ${arguments:-no argument})\n"
- file_verification_check "$archive"
- archive_extract "$archive" "$destination"
- }
- project_sources_archive_update() {
- local project=$1
- shift
- local arguments=$@
- local repository=$project
- local sources_path=$( project_sources_path "$project" "$repository" "$@" )
- local archive=$( project_sources_archive "$project" "$@" )
- local destination=$( dirname "$archive" )
- if [ -d "$sources_path" ]
- then
- rm -rf "$sources_path"
- fi
- printf "Extracting source archive for $project (with ${arguments:-no argument})\n"
- file_verification_check "$archive"
- archive_extract "$archive" "$destination"
- }
- project_sources_archive_missing_error() {
- local project=$1
- shift
- local arguments=$@
- local archive=$( project_sources_archive "$project" "$@" )
- if [ -z "$archive" ] || ! [ -f "$archive" ]
- then
- printf "Missing sources archive for $project (with ${arguments:-no argument})\n" >&2
- return 1
- else
- return 0
- fi
- }
- project_sources_archive_missing_check() {
- local project=$1
- shift
- local archive=$( project_sources_archive "$project" "$@" )
- if [ -z "$archive" ] || ! [ -f "$archive" ]
- then
- return 0
- else
- return 1
- fi
- }
- project_blobs_path() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local configs_path="$project_path/$CONFIGS"
- local argument
- local path
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- local blobs_path="$configs_path/$path/$BLOBS"
- if [ -f "$blobs_path" ]
- then
- echo "$blobs_path"
- return
- fi
- done
- echo "$blobs_path"
- }
- project_blobs_ignore_path() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local configs_path="$project_path/$CONFIGS"
- local argument
- local path
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- blobs_ignore_path="$configs_path/$path/$BLOBS_IGNORE"
- if [ -f "$blobs_ignore_path" ]
- then
- echo "$blobs_ignore_path"
- return
- fi
- done
- }
- project_arguments_targets() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local targets_path="$project_path/$CONFIGS"
- local argument
- for argument in "$@"
- do
- targets_path="$targets_path/$argument"
- done
- targets_path="$targets_path/$TARGETS"
- if [ -f "$targets_path" ]
- then
- cat "$targets_path"
- fi
- }
- project_usage_actions() {
- local project=$1
- shift
- printf "\nGeneric actions:\n"
- for action in $PROJECT_ACTIONS_GENERIC
- do
- if function_check "$action"
- then
- printf " $action\n"
- fi
- done
- if [ $# -gt 0 ]
- then
- printf "\nSpecific actions:\n"
- for action in "$@"
- do
- printf " $action\n"
- done
- fi
- }
- project_usage_arguments() {
- local project=$1
- shift
- printf "\nArguments:\n"
- project_usage_arguments_recursive "$project" " " "$@"
- }
- project_usage_arguments_recursive() {
- local project=$1
- shift
- local spacing=$1
- shift
- local action_helper_arguments
- local argument
- action_helper_arguments=$( project_action_helper "arguments" "$project" "$@" )
- if ! [ -z "$action_helper_arguments" ]
- then
- echo "$action_helper_arguments" | while read argument
- do
- printf "$spacing$argument\n"
- project_usage_arguments_recursive "$project" " $spacing" "$@" "$argument"
- done
- fi
- }
- project_download_git() {
- local project=$1
- shift
- local repository=$1
- shift
- local urls=$1
- shift
- requirements "git"
- if ! git_project_check "$repository"
- then
- project_sources_directory_filled_error "$project" "$repository" "$@"
- git_project_clone "$repository" "$urls"
- fi
- git_project_prepare "$project" "$repository" "$@"
- }
- project_download_check_git() {
- local project=$1
- shift
- local repository=$1
- shift
- requirements "git"
- git_project_check "$repository"
- git_project_prepare_check "$project" "$repository" "$@"
- }
- project_extract() {
- local project=$1
- shift
- local repository=$project
- if ! project_sources_directory_filled_check "$project" "$repository" "$@"
- then
- project_sources_archive_missing_error "$project" "$@"
- project_sources_archive_extract "$project" "$@"
- fi
- }
- project_extract_check() {
- local project=$1
- shift
- local repository=$project
- project_sources_directory_filled_check "$project" "$repository" "$@"
- }
- project_update_git() {
- local project=$1
- shift
- local repository=$1
- shift
- requirements "git"
- project_sources_directory_missing_empty_error "$project" "$repository" "$@"
- if git_project_check "$repository"
- then
- git_project_update "$project" "$repository" "$@"
- else
- if ! project_sources_archive_missing_check "$project" "$@"
- then
- project_sources_archive_update "$project" "$@"
- fi
- fi
- }
- project_update_check_git() {
- local project=$1
- shift
- local repository=$1
- shift
- requirements "git"
- if git_project_check "$repository"
- then
- # Git repository should always be updated (even if upstream didn't progress).
- # For instance, this is useful for testing new versions of patches without changing revision.
- return 1
- else
- project_sources_archive_missing_check "$project" "$@"
- fi
- }
- project_build_check() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local build_path=$( project_build_path "$project" "$@" )
- local source_file_path
- local argument
- local rule
- local path
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- configs_install_path="$project_path/$CONFIGS/$path/$INSTALL"
- if ! [ -f "$configs_install_path" ]
- then
- continue
- fi
- while read rule
- do
- source=$( echo "$rule" | sed "s/$INSTALL_REGEX/\1/g" )
- source_path="$build_path/$source"
- # Source may contain a wildcard.
- path_wildcard_expand "$source_path" | while read source_file_path
- do
- if ! [ -f "$source_file_path" ] && ! [ -d "$source_file_path" ]
- then
- false
- fi
- done
- done < "$configs_install_path"
- done
- }
- project_build_path() {
- local project=$1
- shift
- local build_path="$root/$BUILD/$project"
- local argument
- for argument in "$@"
- do
- build_path="$build_path-$argument"
- done
- echo "$build_path"
- }
- project_build_directory_missing_empty_error() {
- local project=$1
- shift
- local arguments=$@
- local build_path=$( project_build_path "$project" "$@" )
- if ! directory_filled_check "$build_path"
- then
- printf "Build directory for project $project (with ${arguments:-no argument}) missing or empty\n" >&2
- return 1
- else
- return 0
- fi
- }
- project_install() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local build_path=$( project_build_path "$project" "$@" )
- local install_path=$( project_install_path "$project" "$@" )
- local source_file_path
- local argument
- local rule
- local path
- # Install built files first.
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- configs_install_path="$project_path/$CONFIGS/$path/$INSTALL"
- if ! [ -f "$configs_install_path" ]
- then
- continue
- fi
- project_build_directory_missing_empty_error "$project" "$@"
- while read rule
- do
- source=$( echo "$rule" | sed "s/$INSTALL_REGEX/\1/g" )
- source_path="$build_path/$source"
- destination=$( echo "$rule" | sed "s/$INSTALL_REGEX/\2/g" )
- destination_path="$install_path/$destination"
- destination_directory_path=$( dirname "$destination_path" )
- mkdir -p "$destination_directory_path"
- # Source may contain a wildcard.
- path_wildcard_expand "$source_path" | while read source_file_path
- do
- cp -rT "$source_file_path" "$destination_path"
- done
- done < "$configs_install_path"
- done
- path=""
- # Install install files then.
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- install_install_path="$project_path/$INSTALL/$path/$INSTALL"
- if ! [ -f "$install_install_path" ]
- then
- continue
- fi
- while read rule
- do
- source=$( echo "$rule" | sed "s/$INSTALL_REGEX/\1/g" )
- source_path="$project_path/$INSTALL/$path/$source"
- destination=$( echo "$rule" | sed "s/$INSTALL_REGEX/\2/g" )
- destination_path="$install_path/$destination"
- destination_directory_path=$( dirname "$destination_path" )
- mkdir -p "$destination_directory_path"
- # Source may contain a wildcard.
- path_wildcard_expand "$source_path" | while read source_file_path
- do
- cp -rT "$source_file_path" "$destination_path"
- done
- done < "$install_install_path"
- done
- }
- project_install_check() {
- local project=$1
- shift
- local project_path=$( project_path "$project" )
- local build_path=$( project_build_path "$project" "$@" )
- local install_path=$( project_install_path "$project" "$@" )
- local argument
- local rule
- local path
- # Install built files first.
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- configs_install_path="$project_path/$CONFIGS/$path/$INSTALL"
- if ! [ -f "$configs_install_path" ]
- then
- continue
- fi
- project_build_directory_missing_empty_error "$project" "$@"
- while read rule
- do
- destination=$( echo "$rule" | sed "s/$INSTALL_REGEX/\2/g" )
- destination_path="$install_path/$destination"
- if ! [ -f "$destination_path" ] && ! [ -d "$destination_path" ]
- then
- false
- fi
- done < "$configs_install_path"
- done
- path=""
- # Install install files then.
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- if [ -z "$path" ]
- then
- path="$argument"
- else
- path="$path/$argument"
- fi
- fi
- install_install_path="$project_path/$INSTALL/$path/$INSTALL"
- if ! [ -f "$install_install_path" ]
- then
- continue
- fi
- while read rule
- do
- destination=$( echo "$rule" | sed "s/$INSTALL_REGEX/\2/g" )
- destination_path="$install_path/$destination"
- if ! [ -f "$destination_path" ] && ! [ -d "$destination_path" ]
- then
- false
- fi
- done < "$install_install_path"
- done
- }
- project_install_path() {
- local project=$1
- shift
- local install_path="$root/$INSTALL/$project"
- local argument
- for argument in "$@"
- do
- install_path="$install_path-$argument"
- done
- echo "$install_path"
- }
- project_install_directory_missing_empty_error() {
- local project=$1
- shift
- local arguments=$@
- local install_path=$( project_install_path "$project" "$@" )
- if ! directory_filled_check "$install_path"
- then
- printf "Install directory for project $project (with ${arguments:-no argument}) missing or empty\n" >&2
- return 1
- else
- return 0
- fi
- }
- project_release_path() {
- local project=$1
- shift
- local prefix=$1
- local release_path="$root/$RELEASE/$prefix"
- # Special care for tools and systems, that depend on the host arch.
- if [ "$prefix" = "$SYSTEMS" ] || [ "$prefix" = "$TOOLS" ]
- then
- local machine=$( uname -m )
- release_path="$release_path/$machine/$project"
- else
- release_path="$release_path/$project"
- fi
- echo "$release_path"
- }
- project_release_archive_path() {
- local project=$1
- shift
- local prefix=$1
- shift
- local release_path=$( project_release_path "$project" "$prefix" )
- local argument
- local path="$project"
- for argument in "$@"
- do
- path="$path-$argument"
- done
- local archive_path="$release_path/$path.$TAR_XZ"
- echo "$archive_path"
- }
- project_release_rootfs_path() {
- local project=$1
- shift
- local prefix=$1
- shift
- local release_path=$( project_release_path "$project" "$prefix" )
- local argument
- local path="$project"
- for argument in "$@"
- do
- path="$path-$argument"
- done
- local rootfs_path="$release_path/$path.$TAR_XZ"
- echo "$rootfs_path"
- }
- project_release_sources_archive_path() {
- local project=$1
- shift
- local sources_path="$root/$SOURCES/"
- local release_path
- local argument
- local path="$project"
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path-$argument"
- fi
- local directory_path="$sources_path/$path"
- if ! directory_filled_check "$directory_path"
- then
- continue
- fi
- release_path=$path
- done
- if ! [ -z "$release_path" ]
- then
- local archive_path="$root/$RELEASE/$SOURCES/$project/$release_path.$TAR_XZ"
- echo "$archive_path"
- fi
- }
- project_release_sources_archive_create() {
- local project=$1
- shift
- local arguments=$@
- local repository=$project
- local archive_path=$( project_release_sources_archive_path "$project" "$@" )
- local sources_path=$( project_sources_path "$project" "$repository" "$@" )
- printf "Releasing sources archive for $project (with ${arguments:-no argument})\n"
- archive_create "$archive_path" "$sources_path"
- file_verification_create "$archive_path"
- }
- project_release_sources_archive_exists_check() {
- local project=$1
- shift
- local archive_path=$( project_release_sources_archive_path "$project" "$@" )
- if [ -z "$archive_path" ] || ! [ -f "$archive_path" ]
- then
- return 1
- else
- return 0
- fi
- }
- project_release_sources_git() {
- local project=$1
- shift
- local repository=$1
- shift
- requirements "git"
- project_sources_directory_missing_empty_error "$project" "$repository" "$@"
- if git_project_check "$repository"
- then
- if ! git_project_release_check "$project" "$repository" "$@"
- then
- git_project_release "$project" "$repository" "$@"
- fi
- else
- if ! project_release_sources_archive_exists_check "$project" "$@"
- then
- project_release_sources_archive_create "$project" "$@"
- fi
- fi
- }
- project_release_check_sources_git() {
- local project=$1
- shift
- local repository=$1
- shift
- requirements "git"
- if git_project_check "$repository"
- then
- git_project_release_check "$project" "$repository" "$@"
- else
- project_release_sources_archive_exists_check "$project" "$@"
- fi
- }
- project_release_install() {
- local project=$1
- shift
- local prefix=$1
- shift
- local install_path=$( project_install_path "$project" "$@" )
- local release_path=$( project_release_path "$project" "$prefix" )
- local directory_path
- local path
- project_install_directory_missing_empty_error "$project" "$@"
- local files=$( cd "$install_path" && find -type f || true )
- local file
- echo "$files" | while read file
- do
- path="$release_path/$file"
- directory_path=$( dirname "$path" )
- mkdir -p "$directory_path"
- cp "$install_path/$file" "$path"
- file_verification_create "$path"
- done
- }
- project_release_install_check() {
- local project=$1
- shift
- local prefix=$1
- shift
- local install_path=$( project_install_path "$project" "$@" )
- local release_path=$( project_release_path "$project" "$prefix" )
- local path
- project_install_directory_missing_empty_error "$project" "$@"
- local files=$( cd "$install_path" && find -type f || true )
- local file
- echo "$files" | while read file
- do
- path="$release_path/$file"
- file_exists_check "$path"
- done
- }
- project_release_install_archive() {
- local project=$1
- shift
- local prefix=$1
- shift
- project_install_directory_missing_empty_error "$project" "$@"
- project_release_install_archive_create "$project" "$prefix" "$@"
- }
- project_release_install_archive_check() {
- local project=$1
- shift
- project_release_install_archive_exists_check "$project" "$@"
- }
- project_release_install_archive_create() {
- local project=$1
- shift
- local prefix=$1
- shift
- local arguments=$@
- local install_path=$( project_install_path "$project" "$@" )
- local archive_path=$( project_release_archive_path "$project" "$prefix" "$@" )
- printf "Releasing $prefix archive for $project (with ${arguments:-no argument})\n"
- archive_create "$archive_path" "$install_path"
- file_verification_create "$archive_path"
- }
- project_release_install_archive_exists_check() {
- local project=$1
- shift
- local prefix=$1
- shift
- local archive_path=$( project_release_archive_path "$project" "$prefix" "$@" )
- file_exists_check "$archive_path"
- }
- project_release_install_rootfs() {
- local project=$1
- shift
- local prefix=$1
- shift
- project_install_directory_missing_empty_error "$project" "$@"
- if ! project_release_install_rootfs_exists_check "$project" "$prefix" "$@"
- then
- project_release_install_rootfs_create "$project" "$prefix" "$@"
- fi
- }
- project_release_install_rootfs_check() {
- local project=$1
- shift
- project_release_install_rootfs_exists_check "$project" "$@"
- }
- project_release_install_rootfs_create() {
- local project=$1
- shift
- local prefix=$1
- shift
- local arguments=$@
- local install_path=$( project_install_path "$project" "$@" )
- local rootfs_path=$( project_release_rootfs_path "$project" "$prefix" "$@" )
- printf "Releasing $prefix rootfs for $project (with ${arguments:-no argument})\n"
- rootfs_create "$rootfs_path" "$install_path"
- file_verification_create "$rootfs_path"
- }
- project_release_install_rootfs_exists_check() {
- local project=$1
- shift
- local prefix=$1
- shift
- local rootfs_path=$( project_release_rootfs_path "$project" "$prefix" "$@" )
- file_exists_check "$rootfs_path"
- }
- project_clean() {
- local project=$1
- shift
- project_clean_build "$project" "$@"
- project_clean_install "$project" "$@"
- project_clean_release "$project" "$@"
- }
- project_clean_build() {
- local project=$1
- shift
- local build_path=$( project_build_path "$project" "$@" )
- rm -rf "$build_path"
- }
- project_clean_install() {
- local project=$1
- shift
- local install_path=$( project_install_path "$project" "$@" )
- rm -rf "$install_path"
- }
- project_clean_release() {
- local project=$1
- shift
- local prefix
- for prefix in "$SOURCES" "$SYSTEMS" "$IMAGES" "$TOOLS" "$DOCS"
- do
- local release_path=$( project_release_path "$project" "$prefix" )
- rm -rf "$release_path"
- done
- }
- project_clean_rootfs() {
- local project=$1
- shift
- project_clean_build "$project" "$@"
- project_clean_rootfs_install "$project" "$@"
- project_clean_release "$project" "$@"
- }
- project_clean_rootfs_install() {
- local project=$1
- shift
- local install_path=$( project_install_path "$project" "$@" )
- execute_root rm -rf "$install_path"
- }
- project_file_path() {
- local project=$1
- shift
- local directory=$1
- shift
- local file=$1
- shift
- local project_path=$( project_path "$project" )
- local path="$project_path/$directory"
- local argument
- local file_path
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path/$argument"
- fi
- if ! [ -f "$path/$file" ]
- then
- continue
- fi
- file_path="$path/$file"
- done
- if [ -z "$file_path" ]
- then
- return 1
- fi
- echo "$file_path"
- }
- project_file_test() {
- local file_path=$( project_file_path "$@" )
- test -f "$file_path"
- }
- project_file_contents() {
- local file_path=$( project_file_path "$@" )
- if [ -f "$file_path" ]
- then
- cat "$file_path"
- fi
- }
- project_file_contents_herit() {
- local project=$1
- shift
- local directory=$1
- shift
- local file=$1
- shift
- local project_path=$( project_path "$project" )
- local path="$project_path/$directory"
- local argument
- local file_path
- for argument in "" "$@"
- do
- if ! [ -z "$argument" ]
- then
- path="$path/$argument"
- fi
- file_path="$path/$file"
- if ! [ -f "$file_path" ]
- then
- continue
- fi
- cat "$file_path"
- done
- }
|